<?php
namespace Odhen\API\Remote\Printer;

use Odhen\API\Remote\Printer\Command;
use \Zeedhi\Framework\Remote\cURLRequest;

class Printer {

    protected $curl;

    public function __construct($curl) {
        $this->curl = $curl;
        $this->curl->setHeaders(array(
            curlRequest::CONTENT_TYPE_HEADER => curlRequest::CONTENT_TYPE_APPLICATION_JSON
        ));
    }

    public function preparePrint(Command $command) {
        return new Printing($this->curl, $command);
    }

    public function getPrinterStatus($printerType) {
        $result = $this->curl->request('printerStatus', array(
            'printerType' => $printerType
        ));

        $result = json_decode($result, true);

        if ($result['error']) {
            throw new \Exception($result['message']);
        }

        return $result;
    }

}