<?php

/**
 * GepCtrlencasoli
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 19/04/2011 18:29:43 <development@setforms.com>
 * @version    Release: SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GepCtrlencasoli extends DaoGepCtrlencasoli
{


    /**     ok
     * Consulta dados do ultimo encaminhamento de uma determinada solicitacao.
     *
     * @param integer $nrorg       N?o da Organizacao.
     * @param integer $solicitacao N?o da solicitacao.
     *
     * @return Ambigous <boolean, mixed, NULL>
     */
    public static function consultaControle($nrorg, $solicitacao){
        try {

            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRSOLICITACAO = ?',
                array(
                 $nrorg,
                 $solicitacao,
                ),
                'ORDER BY NRCTRLENCASOLI DESC'
            );

                return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**     ok
     * Exclui um resgistro de controle da solicitacao.
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $solicitacao Numero da solicitacao.
     *
     * @return boolean
     */
    public static function excluiControle($nrorg, $solicitacao){
        try {
            $sql = "DELETE GEP_CTRLENCASOLI
                     WHERE NRORG = $nrorg
                       AND NRSOLICITACAO = $solicitacao
                       AND NRCTRLENCASOLI = (SELECT MAX(NRCTRLENCASOLI)
                                               FROM GEP_CTRLENCASOLI
                                              WHERE NRORG = $nrorg
                                                AND NRSOLICITACAO = $solicitacao)";

            \Setforms2\Runtime\Connection::getInstance()->execute($sql);
            return true;
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**      ok
     * Exclui resgistros de controle da solicitacao.
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $solicitacao Numero da solicitacao.
     *
     * @return boolean
     */
    public function excluiControles($nrorg, $solicitacao){
        try {
            $del = "DELETE FROM GEP_CTRLENCASOLI WHERE NRORG = $nrorg AND NRSOLICITACAO = $solicitacao";
            \Setforms2\Runtime\Connection::getInstance()->execute($del);
            return true;
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


}